package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.gson.JsonObject;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingRecipe;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.GsonHelper;
import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.world.item.crafting.RecipeSerializer;

public class Serializer implements RecipeSerializer<ReforgingRecipe> {
  public static final Serializer INSTANCE = new Serializer();
  
  public ReforgingRecipe fromJson(ResourceLocation id, JsonObject obj) {
    DynamicHolder<LootRarity> rarity = RarityRegistry.byLegacyId(GsonHelper.m_13906_(obj, "rarity"));
    int matCost = GsonHelper.m_13927_(obj, "material_cost");
    int sigilCost = GsonHelper.m_13927_(obj, "sigil_cost");
    int levelCost = GsonHelper.m_13927_(obj, "level_cost");
    return new ReforgingRecipe(id, rarity, matCost, sigilCost, levelCost);
  }
  
  public void toNetwork(FriendlyByteBuf buf, ReforgingRecipe recipe) {
    buf.m_130085_(recipe.rarity.getId());
    buf.writeByte(recipe.matCost);
    buf.writeByte(recipe.sigilCost);
    buf.writeByte(recipe.levelCost);
  }
  
  public ReforgingRecipe fromNetwork(ResourceLocation id, FriendlyByteBuf buf) {
    DynamicHolder<LootRarity> rarity = RarityRegistry.INSTANCE.holder(buf.m_130281_());
    return new ReforgingRecipe(id, rarity, buf.readByte(), buf.readByte(), buf.readByte());
  }
}
